/************************************************************
* $Id: gemm1.cl,v 1.4 2015/11/11 11:22:16 mechanoid Exp mechanoid $
*  
* OpenCL matrix multiplication : naive implementation
*
*       OS : GNU/Linux 4.2.3-1-ARCH x86_64 
* COMPILER : GNU project C and C++ Compiler  v.5.2.0
*
*   AUTHOR : Evgeny S. Borisov
*
*    http://www.mechanoid.kiev.ua
*  e-mail : opencl@mechanoid.kiev.ua
* 
************************************************************/

// конвертер индексов матрицы в линейный адрес
#define IDX2LIN(i,j,l) ((i)+(j)*(l))

// A[M*K]   B[K*N]   C[M*N]

__kernel void myGEMM1(const int M, const int N, const int K,
					const __global float* A, const __global float* B, __global float* C) 
{  // номер workitem (2D решетка)
   const int r = get_global_id(0); // строка 0..M
   const int c = get_global_id(1); // столбец 0..N

   // вычисляем элемент [r,c] результирующей матрицы C
   float acc = 0.0f;
   for (int i=0; i<K; i++) {
	  acc += A[ IDX2LIN(r,i,M) ] * B[ IDX2LIN(i,c,K) ];
   }
   C[ IDX2LIN(r,c,M) ] = acc; // сохраняем результат
}

