/************************************************************
* $Id: mat_ops_seq.c,v 1.3 2015/11/09 18:39:28 mechanoid Exp $
*  
*  OpenCL demo
*
*       OS : GNU/Linux 4.2.3-1-ARCH x86_64 
* COMPILER : GNU project C and C++ Compiler  v.5.2.0
*
*   AUTHOR : Evgeny S. Borisov
*
*    http://www.mechanoid.kiev.ua
*  e-mail : opencl@mechanoid.kiev.ua
* 
************************************************************/

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#include "mat_ops_seq.h"

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
int mat_cmp(size_t r, size_t c, data_t* mA, data_t* mB) {
   int ca,cb;
   int pre=10e2;
   int i,j;

   for (i=0; i<r; i++) for (j=0; j<c; j++) {
	  ca = (int)( mA[i*c+j]*pre);
	  cb = (int)( mB[i*c+j]*pre);
	  if(ca!=cb){ fprintf(stdout,"error [ %d %d ] %f != %f \n", i, j, ca/(float)pre,cb/(float)pre); return 1; }
   }
   return 0;
}


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
int mat_print(size_t r,size_t c, data_t* mA) {
   int i,j;
   fprintf(stdout,"\n\n"); 
   for( i=0 ; i<r ; i++ ) {
	  for( j=0 ; j<c ; j++ ) {
		 fprintf(stdout,"%f\t", mA[ IDX2LIN(i,j,r) ]);
	  }
	  fprintf(stdout,"\n");
   }
   return 0;
}


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
void mat_init_rand(size_t s, data_t* mA) {
   int i;
   srand((unsigned int)time(NULL));
   for( i=0 ; i<s ; i++ ) { mA[i] = (float)rand()/(float)RAND_MAX; }
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
void mat_mult_seq(size_t m, size_t n, size_t k, data_t* mA, data_t* mB, data_t* mC ){
   int i,j,t;
   data_t acc = 0.0f;

   for (i=0; i<m; i++) {
	  for(j=0; j<n; j++) {
		 acc = 0.0f;
		 for(t=0; t<k; t++) {
			acc += mA[ IDX2LIN(i,t,m) ] * mB[ IDX2LIN(t,j,k) ];
		 }
		 mC[ IDX2LIN(i,j,m) ] = acc;
	  }
   }
}


