/************************************************************
* $Id: main.c,v 1.2 2015/11/02 16:33:22 mechanoid Exp mechanoid $
*  
*  matrix multiplication (simple) demo
*
*       OS : GNU/Linux 4.2.3-1-ARCH x86_64 
* COMPILER : GNU project C and C++ Compiler  v.5.2.0
*
*   AUTHOR : Evgeny S. Borisov
*
*    http://www.mechanoid.kiev.ua
*  e-mail : opencl@mechanoid.kiev.ua
* 
************************************************************/

#include <stdio.h>
#include <string.h>
#include <time.h>

#include "mat_ops_seq.h"

#define N 1024
#define M 512
#define K 256

data_t hA[M*K];
data_t hB[K*N];
data_t hC[M*N];


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
int main(){
   int i;
   clock_t t;

   t=clock();

   mat_init_rand(M*K,hA);
   mat_init_rand(K*N,hB);
   bzero(hC,N*M*sizeof(data_t));

   mat_mult_seq(M,N,K,hA,hB,hC);

   t=clock()-t;

   //mat_print(M,N,hC);

   printf("\nexecution time: %.1f ms", ((float)t/(float)CLOCKS_PER_SEC)*1000.0  );



   return 0;
}


